//
//  SpawnEditorController.h
//  swordedit
//
//  Created by Fred Havemeyer on 6/1/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class FadeView;
@class HaloMap;
@class Scenario;

@interface SpawnEditorController : NSDocument {
	
	/* Main Content View Related */
	IBOutlet NSView *_contentView;
	IBOutlet NSTableView *spawnEditorTable;
	
	FadeView *_fadeView;
	
	NSView *currentView;
	/* End Main Content View Related */
	
	/* VIEWS */
	
	/* Scenery reference view */
	IBOutlet NSView *scenRefView;
	IBOutlet NSTableView *inactiveSceneryRef;
	IBOutlet NSTableView *activeSceneryRef;
	IBOutlet NSButton *activateScen;
	IBOutlet NSButton *deactivateScen;
	/* End scenery reference view */
	
	
	/* Mapfile related */
	HaloMap *_mapfile;
	Scenario *_scenario;

	NSMutableArray *spawnEditorOptions;
}

- (void)awakeFromNib;
- (void)setNotificationObservers;
- (void)setDataSources;
- (void)setMapFile:(HaloMap *)mapfile;
- (void)destroyAllMapObjects;
- (int)numberOfRowsInTableView:(NSTableView *)tableView;
- (id)tableView:(NSTableView *)tableView objectValueForTableColumn:(NSTableColumn *)tableColumn row:(int)row;
- (void)tableView:(NSTableView *)aTableView willDisplayCell:(id)aCell forTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex;
- (void)tableViewSelectionDidChange:(NSNotification *)aNotification;
- (void)tableView:(NSTableView *)aTableView setObjectValue:(id)anObject forTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex;
- (IBAction)tableViewSelected:(id)sender;
- (IBAction)buttonAction:(id)sender;
- (void)_switchTo:(NSView *)destination from:(NSView *)source;
- (void)fadeViewFinishedAnimation:(FadeView *)theView;
@end
